<?php

class i_pressbooks_5_9_0_install extends i_action_install
{
public function step2_init() {}
public function step2_process()
{
	
		$this->extract("main");
		$this->extract("data");
		$this->extract("pressbooks");
		$this->mkdir("wp-content/plugins/pressbooks");
		$this->mv('pressbooks/*','wp-content/plugins/pressbooks/');
		$this->rm('pressbooks');
		
		// McLuhan Theme
		$this->extract("mcluhan");
		$this->mkdir("wp-content/themes/pressbooks-book");
		$this->mv('pressbooks-book/*','wp-content/themes/pressbooks-book');
		$this->rm('pressbooks-book');
		
		// Aldine Theme
		$this->extract("aldine");
		$this->mkdir("wp-content/themes/pressbooks-aldine");
		$this->mv('pressbooks-aldine/*','wp-content/themes/pressbooks-aldine');
		$this->rm('pressbooks-aldine');
		
		// Jacobs Theme
		$this->extract("jacobs");
		$this->mkdir("wp-content/themes/pressbooks-jacobs");
		$this->mv('pressbooks-jacobs-1.2.0/*','wp-content/themes/pressbooks-jacobs');
		$this->rm('pressbooks-jacobs-1.2.0');
		
		// Luther Theme
		$this->extract("luther");
		$this->mkdir("wp-content/themes/pressbooks-luther");
		$this->mv('pressbooks-luther-1.8.3/*','wp-content/themes/pressbooks-luther');
		$this->rm('pressbooks-luther-1.8.3');
		
		// Clarke Theme
		$this->extract("clarke");
		$this->mkdir("wp-content/themes/pressbooks-clarke");
		$this->mv('pressbooks-clarke-2.3.1/*','wp-content/themes/pressbooks-clarke');
		$this->rm('pressbooks-clarke-2.3.1');
		
		// Donham Theme
		$this->extract("donham");
		$this->mkdir("wp-content/themes/pressbooks-donham");
		$this->mv('pressbooks-donham-1.7.0/*','wp-content/themes/pressbooks-donham');
		$this->rm('pressbooks-donham-1.7.0');
		
		// Austen Classic Theme
		$this->extract("austenclassic");
		$this->mkdir("wp-content/themes/pressbooks-austenclassic");
		$this->mv('pressbooks-austenclassic-1.7.0/*','wp-content/themes/pressbooks-austenclassic');
		$this->rm('pressbooks-austenclassic-1.7.0');
		
		// Fitzgerald Theme
		$this->extract("fitzgerald");
		$this->mkdir("wp-content/themes/pressbooks-fitzgerald");
		$this->mv('pressbooks-fitzgerald-1.6.1/*','wp-content/themes/pressbooks-fitzgerald');
		$this->rm('pressbooks-fitzgerald-1.6.1');
		
		// BC Textbook Plugin
		$this->extract("bctextbooks");
		$this->mv('pressbooks-textbook','wp-content/plugins/pressbooks-textbook');
		$this->rm('pressbooks-textbook');
		
		// mPDF Plugin
		$this->extract("mpdf");
		$this->mv('pressbooks-mpdf','wp-content/plugins/pressbooks-mpdf');
		$this->rm('pressbooks-mpdf');
		
		// LTI Plugin
		$this->extract("lti");
		$this->mv('pressbooks-lti-provider','wp-content/plugins/pressbooks-lti-provider');
		$this->rm('pressbooks-lti-provider');
		
		
		$this->mv('wordpress/*');
		$this->rm('wordpress');
		$this->mkdir(array('wp-content/uploads','wp-content/languages', "wp-content/uploads/et_temp"));
		$this->chmod("wp-content", 0666, 0777, true);
		$this->chmod("wp-content/index.php", 0644);

		$urlinfo = parse_url($this->url);
		$this->write(".htaccess",'
# BEGIN WordPress
RewriteEngine On
RewriteBase '.$urlinfo["path"].'/
RewriteRule ^index\.php$ - [L]

# uploaded files
RewriteRule ^([_0-9a-zA-Z-]+/)?files/(.+) wp-includes/ms-files.php?file=$2 [L]

# add a trailing slash to /wp-admin
RewriteRule ^([_0-9a-zA-Z-]+/)?wp-admin$ $1wp-admin/ [R=301,L]

RewriteCond %{REQUEST_FILENAME} -f [OR]
RewriteCond %{REQUEST_FILENAME} -d
RewriteRule ^ - [L]
RewriteRule ^[_0-9a-zA-Z-]+/(wp-(content|admin|includes).*) $1 [L]
RewriteRule ^[_0-9a-zA-Z-]+/(.*\.php)$ $1 [L]
RewriteRule . '.$urlinfo["path"].'/index.php [L]
# END WordPress');

		$this->cp('wp-config-sample.php','wp-config.php');
		$r = array(
			"#'localhost'#"			=> var_export($this->db_host,true),
			"#'username_here'#"		=> var_export($this->db_user,true),
			"#'database_name_here'#"	=> var_export($this->db_name,true),
			"#'password_here'#"	=> var_export($this->db_pass,true),
			"#'wp_'#"				=> var_export($this->db_prefix,true),
			"#define\( 'AUTH_KEY',.+'put your unique phrase here' \);#s" //matches whole block
				=>
"define('AUTH_KEY',         ".var_export(i_lib::randstr(64),true).");
define('SECURE_AUTH_KEY',  ".var_export(i_lib::randstr(64),true).");
define('LOGGED_IN_KEY',    ".var_export(i_lib::randstr(64),true).");
define('NONCE_KEY',        ".var_export(i_lib::randstr(64),true).");
define('AUTH_SALT',        ".var_export(i_lib::randstr(64),true).");
define('SECURE_AUTH_SALT', ".var_export(i_lib::randstr(64),true).");
define('LOGGED_IN_SALT',   ".var_export(i_lib::randstr(64),true).");
define('NONCE_SALT',       ".var_export(i_lib::randstr(64),true).");

/**
 * Other customizations.
 */
"
.( $this->env["has_php_suexec"] === false && $this->env["has_php_safe_mode"] !== false ? "" : "define('FS_METHOD','direct');".( $this->env["has_php_suexec"] !== false ? "define('FS_CHMOD_DIR',0755);define('FS_CHMOD_FILE',0644);" : "define('FS_CHMOD_DIR',0777);define('FS_CHMOD_FILE',0666);" )."\n" )
."define('WP_TEMP_DIR',dirname(__FILE__).'/wp-content/uploads');

/**
 * Turn off automatic updates since these are managed upstream.
 */
define('AUTOMATIC_UPDATER_DISABLED', true);

/**
 * Multi-site
 *
 */
define('MULTISITE', true);
define('SUBDOMAIN_INSTALL', false);
\$base = ".var_export($urlinfo["path"]."/",true).";
define('DOMAIN_CURRENT_SITE', ".var_export($urlinfo["host"],true).");
define('PATH_CURRENT_SITE', ".var_export($urlinfo["path"]."/",true).");
define('SITE_ID_CURRENT_SITE', 1);
define('BLOG_ID_CURRENT_SITE', 1);
define('WP_ALLOW_MULTISITE', true);

define( 'PB_KINDLEGEN_COMMAND', '/opt/kindlegen/kindlegen' );
define( 'PB_EPUBCHECK_COMMAND', '/usr/bin/java -jar /opt/epubcheck/epubcheck.jar' );
define( 'PB_XMLLINT_COMMAND', '/usr/bin/xmllint' );
define( 'PB_SAXON_COMMAND', '/usr/bin/java -jar /opt/saxon-he/saxon-he.jar' );
");
		$this->sr("wp-config.php", $r);
    $r = array(
				"#ynri_#" => $this->db_prefix,
				"#http://www.testing.installatron.com/djfkl#" => $this->url,
				"#'www.testing.installatron.com'#" => "'".$urlinfo["host"]."'",
				"#'/djfkl/'#" => "'".$urlinfo["path"]."/'",
			);
		$this->db_import("install.sql", null, $r);
		$this->rm("install.sql");

		$sql = "";
		$sql .= "UPDATE `{$this->db_prefix}posts` SET post_date=NOW(), post_date_gmt=NOW(), post_modified=NOW(), post_modified_gmt=NOW();\n";
		$sql .= "UPDATE `{$this->db_prefix}users` SET user_pass='".md5($this->input["field_passwd"])."', user_login='".$this->db_escape($this->input["field_login"])."', user_email='".$this->db_escape($this->input["field_email"])."', user_registered=NOW() WHERE ID='1';\n";
		$this->db_query("UPDATE `{$this->db_prefix}sitemeta` SET `meta_value`=? WHERE `meta_key`='site_admins'",array(serialize(array($this->input["field_login"]))));
		$this->db_query("UPDATE `{$this->db_prefix}sitemeta` SET `meta_value`=? WHERE `meta_key`='admin_email'",array($this->input["field_email"]));
		$sql .= "UPDATE `{$this->db_prefix}options` SET `option_value`='".$this->db_escape("$this->path/wp-content/uploads")."' WHERE `option_name`='upload_path';\n";
		$sql .= "UPDATE `{$this->db_prefix}options` SET `option_value`='".$this->db_escape($this->input["field_email"])."' WHERE `option_name`='admin_email';\n";
		$sql .= "UPDATE `{$this->db_prefix}usermeta` SET `meta_value`='0' WHERE `meta_key`='default_password_nag' AND `user_id`='1';\n";

		$sql .= "UPDATE `{$this->db_prefix}options` SET `option_value`='1' WHERE `option_name`='blog_public';\n";

		// use permalinks instead of query string
		if ( !isset($this->env["has_apache"]) || $this->env["has_apache"] !== false || $this->env["has_nginx"] !== false )
		{
			$sql .= "UPDATE `{$this->db_prefix}options` SET `option_value`='".( $this->ds === "/" ? "/%category%/%postname%/" : "" )."' WHERE `option_name`='permalink_structure';\n";
		}

		$sql .= "INSERT INTO `{$this->db_prefix}options` (`option_name`, `option_value`) VALUES
('ftp_credentials', '".$this->db_escape(serialize(array( "hostname" => "localhost", "username" => $this->input["field_ftpuser"], "connection_type" => "ftp" )))."');\n";

		$this->write("install2.sql",$sql);
		$this->db_import("install2.sql");
		$this->rm("install2.sql");

		$this->chmod(array(".htaccess","wp-config.php"),0666);

                // to fix the upgrade screen after the first install:
		$r = $this->fetch('wp-admin/upgrade.php?step=1', null, null, false);
		$this->cp("wp-admin/network/upgrade.php", "wp-admin/network/upgrade.php.bak");
		$this->sr("wp-admin/network/upgrade.php",array(
				"#require_once\( './admin.php' \);#" => "require( '../../wp-load.php' );set_time_limit(0);",
				"#get_current_screen\(\)->add.+'</h2>';#sim" => "",
				"#LIMIT ..n., 5#" => ""
			));

		$this->fetch("wp-admin/network/upgrade.php?action=upgrade", null, null, false);

		sleep(5);
		$this->mv("wp-admin/network/upgrade.php.bak", "wp-admin/network/upgrade.php");

$this->write("wp-includes/.htaccess","<Files *.php>
deny from all
</Files>
<Files wp-tinymce.php>
allow from all
</Files>
<Files ms-files.php>
allow from all
</Files>");

		$this->rm("readme.html");
		$this->mkdir("wp-content/mu-plugins");
		$this->mv("wp-content/plugins/pressbooks/hm-autoloader.php","wp-content/mu-plugins/");
		
    $this->write("wpinstall.sh", "#!/bin/bash
cd {$this->path}
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' plugin activate pressbooks --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' core update-db --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-book --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-aldine --network --activate
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-jacobs --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-luther --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-clarke --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-donham --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-austenclassic --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' theme enable pressbooks-fitzgerald --network
sudo -u {$this->owner['user']} /usr/local/bin/php /usr/local/bin/wp --allow-root --path='{$this->path}' plugin activate pressbooks-mpdf --network
");


$this->sr("wpinstall.sh", "#\r\n#", "\n");
exec("/usr/bin/nohup /bin/sh {$this->path}/wpinstall.sh &> /dev/null &");
$this->fetch("wp-admin/index.php");


}
}

?>